//
//  OJSDateExtension.swift
//  LXMBlockKit
//
//  Created by luxiaoming on 2019/4/20.
//

import UIKit

public let dateFormatter = DateFormatter()
private let kCurrentCalendar = Calendar.current

extension Date {

    func fullTimeString() -> String {
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
        let desDateString = dateFormatter.string(from: self)
        return desDateString
    }
    
    func isToday() -> Bool {
        return kCurrentCalendar.isDateInToday(self)
    }
    
    
}

/// 将秒数转换为00：00：00的格式，如果小时为0，则只返回00：00
public func timeStringForDuration(withSeconds seconds: TimeInterval) -> String {
    let seconds = Int(seconds)
    let ss = seconds % 60
    let hh = seconds / 3600
    let mm = (seconds / 60) % 60
    var result = ""
    if hh > 0 {
        result += String(format: "%02d:", hh)
    }
    result += String(format: "%02d:", mm)
    result += String(format: "%02d", ss)
    return result
}

public func timeStringForHuman(widthSeconds seconds: TimeInterval) -> String {
    let now = Date()
    let targetDate = Date(timeIntervalSince1970: seconds)
    let seconds = Int(seconds)
    let hh = seconds / 3600
    let mm = (seconds / 60) % 60
    
    var resultString = ""
    
    if kCurrentCalendar.isDateInToday(targetDate) {
        if hh == 0 && mm == 0 {
            resultString = "刚刚"
        } else if hh == 0 {
            resultString = String(format: "%d分钟前", mm)
        } else {
            resultString = String(format: "%d小时前", hh)
        }
    }
    else if kCurrentCalendar.isDateInYesterday(targetDate) {
        dateFormatter.dateFormat = "昨天 HH:mm"
        resultString = dateFormatter.string(from: targetDate)
    }
    else if kCurrentCalendar.isDate(targetDate, equalTo: now, toGranularity: .year) {
        dateFormatter.dateFormat = "MM-dd HH:mm"
        resultString = dateFormatter.string(from: targetDate)
    }
    else {
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm"
        resultString = dateFormatter.string(from: targetDate)
    }
    return resultString
    
}





