//
//  OJSDefines.swift
//  OJASwiftKitDemo
//
//  Created by luxiaoming on 2016/11/14.
//  Copyright © 2016年 luxiaoming. All rights reserved.
//

import Foundation
import UIKit

public let kOJSScreenBounds: CGRect = UIScreen.main.bounds
public let kOJSScreenSize: CGSize = kOJSScreenBounds.size
public let kOJSScreenWidth: CGFloat = kOJSScreenBounds.width
public let kOJSScreenHeight: CGFloat = kOJSScreenBounds.height
public let kOJSUserDefaults: UserDefaults = UserDefaults.standard
public let kOJSNotificationCenter: NotificationCenter = NotificationCenter.default
public let kOJSFileManager: FileManager = FileManager.default

public let kOJSShortVersionString: String = Bundle.main.object(forInfoDictionaryKey: "CFBundleShortVersionString") as! String
public let kOJSBuildString: String = Bundle.main.object(forInfoDictionaryKey: "CFBundleVersion") as! String

/// 这个只取大版本号，比如7，7.1，7.2.1都返回7
public let kOJSSystemVersion = Int(UIDevice.current.systemVersion.components(separatedBy: ".").first!)!



public let kOJSIs320_480: Bool = kOJSScreenSize.equalTo(CGSize(width: 320, height: 480))
public let kOJSIs320_568: Bool = kOJSScreenSize.equalTo(CGSize(width: 320, height: 568))
public let kOJSIs375_667: Bool = kOJSScreenSize.equalTo(CGSize(width: 375, height: 667))
public let kOJSIs414_736: Bool = kOJSScreenSize.equalTo(CGSize(width: 414, height: 736))
public let kOJSIs375_812: Bool = kOJSScreenSize.equalTo(CGSize(width: 375, height: 812))
public let kOJSIs414_896: Bool = kOJSScreenSize.equalTo(CGSize(width: 414, height: 896))


public let kOJSIsNotchiPhone: Bool = kOJSIs375_812 || kOJSIs414_896


public let kOJSNavigationBarHeight: CGFloat = kOJSIsNotchiPhone ? 88 : 64
public let kOJSStatusBarHeight: CGFloat = kOJSIsNotchiPhone ? 44 : 20
public let kOJSTabBarHeight: CGFloat = kOJSIsNotchiPhone ? 83 : 49
public let kOJSBottomMarginHeight: CGFloat = kOJSIsNotchiPhone ? 34 : 0

